#!/bin/bash

# uninstall logic for ReStore A-Click Backup 6.17.0.2
# The root privilege is required to uninstall the application

###############################################################################
#             S H U T - D O W N                 S E R V I C E S               #
###############################################################################

# Shutdown Scheduler
if [ -e "/Applications/Restore A-Click Backup/ipc/Scheduler/running" ]; then
    echo "Shutdown Scheduler for ReStore A-Click Backup"
    touch "/Applications/Restore A-Click Backup/ipc/Scheduler/stop"
    echo "Wait 5 seconds before Scheduler exits"
    sleep 5
fi

# Shutdown AutoUpdateAgent
if [ -e "/Applications/Restore A-Click Backup/aua/bin" ]; then
    echo "Shutdown AutoUpdateAgent for ReStore A-Click Backup"
    sh "/Applications/Restore A-Click Backup/aua/bin/shutdown.sh"
    echo "Wait 5 seconds before AutoUpdateAgent exits"
    sleep 5
fi

###############################################################################
#        T A S K K I L L       A L L      J A V A       P R O C E S S         #
###############################################################################

# Kill all running process
sh "/Applications/Restore A-Click Backup/bin/taskkill" "/Applications/Restore A-Click Backup/BackupManager.app"
sh "/Applications/Restore A-Click Backup/bin/taskkill" "/Applications/Restore A-Click Backup/bin/BackupManager.app"
sh "/Applications/Restore A-Click Backup/bin/taskkill" "/Applications/Restore A-Click Backup/jvm/bin/java"
sh "/Applications/Restore A-Click Backup/bin/taskkill" "/Applications/Restore A-Click Backup/aua/jvm/bin/java"

###############################################################################
#                 R E M O V E                   S E R V I C E S               #
###############################################################################

# Remove Scheduler
if [ -e "/Library/StartupItems/RestoreA-ClickBackup" ]; then
    echo "Remove Scheduler for ReStore A-Click Backup from service"
    rm -rf "/Library/StartupItems/RestoreA-ClickBackup"
fi

# Remove AutoUpdateAgent
if [ -e "/Library/StartupItems/RestoreA-ClickBackup-AutoUpdate" ]; then
    echo "Remove AutoUpdateAgent for ReStore A-Click Backup from service"
    rm -rf "/Library/StartupItems/RestoreA-ClickBackup-AutoUpdate"
fi

###############################################################################
#      R E M O V E        U S E R         D E S K T O P      L I N K          #
###############################################################################

# Remove Desktop Symbolic Link
find /Users -name Desktop -type d -maxdepth 3 -mindepth 2 | while read DESKTOP_PATH;
do
    if [ -e "${DESKTOP_PATH}/RestoreA-ClickBackup" ]; then
        echo "Remove Desktop Link RestoreA-ClickBackup from path ${DESKTOP_PATH}"
        rm -f "${DESKTOP_PATH}/RestoreA-ClickBackup"
        echo "Removed ReStore A-Click Backup Desktop Link"
    fi

    if [ -e "${DESKTOP_PATH}/Restore A-Click Backup" ]; then
        echo "Remove Desktop Link Restore A-Click Backup from path ${DESKTOP_PATH}"
        rm -f "${DESKTOP_PATH}/Restore A-Click Backup"
        echo "Removed ReStore A-Click Backup Desktop Link"
    fi
done

###############################################################################
#        R E M O V E           A P P L I C A T I O N           H O M E        #
###############################################################################

# Remove ReStore A-Click Backup
cd /
if [ -e "/Applications/Restore A-Click Backup" ]; then
    echo "Remove ReStore A-Click Backup from Your Mac OS X"
    rm -rf "/Applications/Restore A-Click Backup"
fi

###############################################################################
#        R E M O V E             M A C     O S        R E C E I P T S         #
###############################################################################

# Remove Mac OS X Receipts
if [ -e "/Library/Receipts/acb.pkg" ]; then
    echo "Remove Mac OS X Receipt for acb.pkg (Path: /Library/Receipts/acb.pkg)"
    rm -rf "/Library/Receipts/acb.pkg"
fi
